;;                
;;GNQ-5642BS-21 (   E4056-I-O-O-W      ).   -   
;;  .     DS18B20/

;------------------------------------------------------------------------------- 



	list	P=PIC16F628A 

#include <P16F628A.INC>




;  !!!  	1.        0  
;   0h   1Fh
;              			2.          
; 
OZU1         		EQU     20h; 
OZUMS         		EQU		21h ;     

MIN		        	EQU     022H           ;  ( )
DMIN        		EQU     023H           ;   ( )
UHR         		EQU     024H           ;  (      -)
DUHR          		EQU     025H           ;   (  )
BUF       			EQU     026H           ; 
BUF_PRI        		EQU     027H           ;  USART
; :    (...)-    

BUF_BX     		   	EQU     028H           ; 
B1         			EQU     029H           ;  1 
B2           		EQU     02AH           ;  2
B3          		EQU     02BH           ;  3
B4           		EQU     02CH           ;  4
B5           		EQU     02DH           ;  5
B6           		EQU     02EH           ;  6
B7           		EQU     02FH           ;  7
B8             		EQU     030H           ;  8 (CRC)
KOM             	EQU     031H           ;   

TEMPER 		       	EQU     032H           ;     
COUNT_IND	   	  	EQU     033H  	
ZNAK_T		   	  	EQU     034H ;  
 	
;  - 3F14 -   4 ,    
; (    )                           

; /     RA    
;      -RA0 -    ("0" - )
;      -RA1 -   B ("0" - )
;       RA2 -   C ("0" - )
;      -RA3 -   D ("0" - )
;      -RA4 -   E ("0" - )
;      -RA5 - ,    
;       RA6 -   F ("0" - )
;      -RA7 -   G ("0" - )

;      RB  
;	-RB0-    USART
;	-RB1-USART
;	-RB2-    DS18B20
;	-RB3-     (   )
;	-RB4-   
;	-RB5-    
;	-RB6-   
;	-RB7-     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;   
;     -G-    -F-    -_-    -E-    -D-   -C-     -B-     -A- 
; PORTA       -7-    -6-    -5-    -4-    -3-   -2-     -1-     -0- 
;   "0"   1      0      1      0      0     0       0       0      ; b'10100000'
;   "1"   1      1      1      1      1     0       0       1      ; b'11111001'  
;   "2"   0      1      1      0      0     1       0       0      ; b'01100100'   
;   "3"   0      1      1      1      0     0       0       0      ; b'01110000'   
;   "4"   0      0      1      1      1     0       0       1      ; b'00111001'  
;   "5"   0      0      1      1      0     0       1       0      ; b'00110010'    
;   "6"   0      0      1      0      0     0       1       0      ; b'00100010' 
;   "7"   1      1      1      1      1     0       0       0      ; b'11111000' 
;   "8"   0      0      1      0      0     0       0       0      ; b'00100000'  
;   "9"   0      0      1      1      0     0       0       0      ; b'00110000'  
;   1      1      1      1      1     1       1       1      ; b'11111111' 
;;;     
;         1      0      1      0      0     1       1       0      ; b'10100110'
;         0      0      1      1      1     1       0       0      ; b'00111100' 
;     -    0      1      1      1      1     1       1       1      ; b'01111111' 
;     E    0      0      1      0      0     1       1       0      ; b'00100110'
;     r    0      1      1      0      1     1       1       1      ; b'01101111'


   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
		org 0
		GOTO  SBROS

		
SBROS:
;		        
 
;       
	MOVLW b'00100000'; 
	BSF  STATUS,5	;    1
	TRIS PORTA ;	   PORTA    ,  RA5,       
	BCF  STATUS,5;    0	
	MOVLW b'11111111'  ;    ,   
	MOVWF    PORTA

	BSF  CMCON,0   ;   RA0-RA3  
	BSF  CMCON,1
	BSF  CMCON,2

	movlw b'00000010'  
	BSF  STATUS,5	;    1	
	TRIS PORTB ;     PORTB   ,  1  (  USART)
	BCF  STATUS,5;    0	
	MOVLW b'11111101'  ;    B,    ,    
	MOVWF    PORTB

;      
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     RB2 
DAT1:
;     
		CALL INIC_DAT1

 

;      .  "  " ( )
 	MOVLW  b'10100110'
	MOVWF  MIN
 	MOVLW b'00111100'
	MOVWF  DMIN
  	MOVLW b'11111111'
	MOVWF  UHR
	MOVLW b'11111111'
	MOVWF  DUHR

		CALL IND250 ;      1 

;;  
			BSF PORTB,4
			BSF PORTB,5			
			BSF PORTB,6
			BSF PORTB,7
		CALL WYWOD_TEMPER1
		CALL RAS_TEMPER
		CALL INIC_DAT1

			MOVF TEMPER,0;
			CALL TAB_HEX_ED
				CALL TAB1
			MOVWF DMIN

			MOVF TEMPER,0;
			CALL TAB_HEX_DES
				CALL TAB1;
			MOVWF UHR

		MOVF 	ZNAK_T,0
		MOVWF DUHR

		MOVLW b'00111100' ;;;  
		MOVWF  MIN

		CALL IND250

;    
		CALL WYWOD_TEMPER1
		CALL RAS_TEMPER
;		CALL INIC_DAT1

			MOVF TEMPER,0;
			CALL TAB_HEX_ED
				CALL TAB1
			MOVWF DMIN

			MOVF TEMPER,0;
			CALL TAB_HEX_DES
				CALL TAB1;
			MOVWF UHR

		MOVF 	ZNAK_T,0
		MOVWF DUHR

		MOVLW b'00111100' ;;;  
		MOVWF  MIN

		CALL IND250

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;       

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       USART (  )
DIEUHR:

	BSF STATUS,5;   1
;     
	MOVLW b'00010110';  22 .    
	MOVWF  SPBRG     ; (  2717 /   2731)
;	MOVLW b'00110011';  51 .    (  1200 /)
;	MOVWF  SPBRG     ; 
;	BCF   TXSTA,0 ;  9- 
;	BSF   TXSTA,1 ;    ( )
	BCF   TXSTA,2 ;    ;	BSF   TXSTA,2 ;   
;	BSF   TXSTA,3 ; 
	BCF   TXSTA,4 ;   
;	BCF   TXSTA,6 ;   9-  
;	BSF   TXSTA,7 ;   -     .
;	BSF   TXSTA,5 ;   
	BCF STATUS,5;   0
;    
	BSF RCSTA,0 ; 9-  ( )
;	BSF RCSTA,1 ;      ( )
;	BSF RCSTA,2 ;    (   ) ( )
;	BSF RCSTA,3 ;  9-    -  8-    
	BSF RCSTA,4 ;      
;	BSF RCSTA,5 ;???????-  .  
	BSF RCSTA,6 ;    9- ; 
;      BCF RCSTA,6 ;    8- 
	BSF RCSTA,7 ;    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	CLRF INTCON
	CLRF PIR1
	BSF STATUS,5;   1
	CLRF PIE1
	BCF STATUS,5;   0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 


;      ( )
;	MOVLW   b'00001010'
;	MOVWF  MIN
;	MOVWF  DMIN
;	MOVWF  UHR
;	MOVWF  DUHR

	MOVLW   b'00001010'
	MOVWF  MIN
	MOVWF  DMIN
	MOVWF  UHR
	MOVWF  DUHR

		BSF PORTB,0 ;      USART
L1:                 ;    ,           USART
	BSF  PORTB,7
 	MOVF  MIN,0 
	MOVWF BUF
    CALL  TAB1
	MOVWF  PORTA
	BCF  PORTB,4
	CALL  PRIEM_T
	CALL  MS01	


	BSF  PORTB,4
 	MOVF  DMIN,0 
	MOVWF BUF
	CALL  TAB1    
	MOVWF  PORTA
	BCF  PORTB,5
	CALL  PRIEM_T
	CALL  MS01	

	BSF  PORTB,5
 	MOVF  UHR,0  
	MOVWF BUF
	CALL TAB1   
	MOVWF  PORTA
	BCF  PORTB,6
	CALL  PRIEM_T
	CALL  MS01	

	BSF  PORTB,6
 	MOVF  DUHR,0 
	MOVWF BUF
	CALL  TAB1    
	MOVWF  PORTA
	BCF  PORTB,7
	CALL  PRIEM_T
	CALL  MS01	
	GOTO  L1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;         
WYWOD_TEMPER1:
;     (8 )  CRC.

	BCF  PORTB,2;
	CALL MKS500;   500 
	BSF  PORTB,2 ;
	CALL MKS100;   100 
				CALL RB2_PR;
	      BTFSC  PORTB,2 ;
	GOTO  SBROS
				CALL RB2_WY  ;
	CALL  MS01
;  SKIP ROM [CCh].
	MOVLW 0CCH
	MOVWF  KOM
	CALL BYD_KOM1
	CALL  MS01
	
;  READ SCRATCHPAD [BEh](10111110).
	MOVLW 0BEH
	MOVWF  KOM
	CALL BYD_KOM1
	CALL  MS01	

 	CALL  READ1
	MOVF  BUF_BX,0
	MOVWF  B1
	
 	CALL READ1
	MOVF  BUF_BX,0
	MOVWF  B2
	CALL   MS10
			RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   ,   
RAS_TEMPER:
; 	CALL READ		;      ( ) 
;	MOV  B3,BUF_BX 	;   6-  
;	CALL READ	
;	MOV  B4,BUF_BX
;	CALL READ
;	MOV  B5,BUF_BX
;	CALL READ
;	MOV  B6,BUF_BX
;	CALL READ
;	MOV  B7,BUF_BX
;	CALL READ
;	MOV  B8,BUF_BX

;              DS18B20
;                                   B2                B1
;    +125C           0000 0111    1101 0000     07D0h
;    +85C             0000 0101    0101 0000     0550h
;    +25.0625C    0000 0001    1001 0001     0191h
;    +10.125C      0000 0000    1010 0010     00A2h
;    +0.5C            0000 0000    0000 1000     0008h
;      0C               0000 0000    0000 0000     0000h
;    -0.5C            1111 1111     1111 1000    FFF8h
;    -10.125C      1111 1111     0101 1110    FF5Eh
;    -25.0625C    1111 1110     0110 1111    FE6Fh
;    -55C             1111 1100     1001 0000    FC90h
;


;         
;        
;         1    2  
;              

;      		RA0="0" -  ,  
;									 	RA0="1" -   ,  


;   
;    +25 (0191h)
;		MOVLW    091H
;		MOVWF   B1
;		MOVLW    001H
;		MOVWF   B2
;    -25 (FE6Fh)
;		MOVLW   06FH
;		MOVWF   B1
;		MOVLW   0FEH
;		MOVWF   B2		
		


	BTFSS B2,7
	GOTO  POL  ;   
	GOTO  OTR ;   
;  -------------------------------------------------------------------
;            TEMPER
POL: 
;			MOVLW  0FFH
;			MOVWF  TEMPER
;     
;		BSF PORTA,2
		CLRF TEMPER
;;;     ,   
; 	MOVLW b'01111111'
;	MOVWF  DMIN
  	MOVLW b'11111111'
	MOVWF  ZNAK_T

;      TEMPER
	BTFSC B1,4	
	BSF     TEMPER,0
	BTFSC B1,5	
	BSF     TEMPER,1
	BTFSC B1,6	
	BSF     TEMPER,2			
	BTFSC B1,7	
	BSF     TEMPER,3
	BTFSC B2,0	
	BSF     TEMPER,4
	BTFSC B2,1	
	BSF     TEMPER,5
	BTFSC B2,2	
	BSF     TEMPER,6

;     
;		MOVLW .5
;		MOVWF  TEMPER	
	
	GOTO  BYXOD
;  -------------------------------------------------------------------
;      
OTR:
;     
;	BCF PORTA,2
		MOVLW 0FFH
		MOVWF  TEMPER
;;;     ,    ( - )
 	MOVLW b'01111111'
	MOVWF  ZNAK_T

	
	BTFSC B1,4	
	BCF     TEMPER,0
	BTFSC B1,5	
	BCF     TEMPER,1
	BTFSC B1,6	
	BCF     TEMPER,2			
	BTFSC B1,7	
	BCF     TEMPER,3
	BTFSC B2,0	
	BCF     TEMPER,4
	BTFSC B2,1	
	BCF     TEMPER,5	
	BTFSC B2,2	
	BCF     TEMPER,6
		BCF TEMPER,7
BYXOD:
				RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   (  )

ER:
 	MOVLW  b'01101111'
	MOVWF  MIN
 	MOVLW  b'00100110'
	MOVWF  DMIN
  	MOVLW b'10100110'
	MOVWF  UHR
	MOVLW b'00111100'
	MOVWF  DUHR

		CALL IND250

		GOTO DIEUHR;   SBROS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
INIC_DAT1:
;     

	BCF  PORTB,2  ;
	CALL MKS500;   500 
		CALL RB2_PR ;
	CALL MKS100;   100 


     BTFSC PORTB,2  ;;;;;;;;;;;;;;;; PORTA,6; 
	GOTO ER ;    ,    
		CALL RB2_WY  ;
	BSF PORTB,2  ;
	CALL  MS01
;  SKIP ROM [CCh].
	MOVLW 0CCH
	MOVWF  KOM
	CALL BYD_KOM1
	CALL  MS01
;  CONVERT T[44h](01000100)
	MOVLW 044H
	MOVWF  KOM
	CALL BYD_KOM1

		RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        1
BYD_KOM1:

;  0 
	BCF PORTB,2  ;
	CALL MKS05;
	BTFSC  KOM,0
	BSF PORTB,2  ;		
	CALL MKS60;		
	BSF PORTB,2  ;
	CALL MKS500;
;  1
	BCF  PORTB,2  ;
	CALL MKS05;
	BTFSC  KOM,1
	BSF  PORTB,2  ;		
	CALL MKS60;		
	BSF  PORTB,2  ;
	CALL MKS500;
;  2
	BCF  PORTB,2  ;
	CALL MKS05;
	BTFSC  KOM,2
	BSF  PORTB,2  ;
	CALL MKS60;		
	BSF  PORTB,2  ;
	CALL MKS500;
;  3
	BCF PORTB,2  ;
	CALL MKS05;
	BTFSC  KOM,3
	BSF  PORTB,2  ;
	CALL MKS60;		
	BSF  PORTB,2  ;
	CALL MKS500;
;  4
	BCF  PORTB,2  ;
	CALL MKS05;
	BTFSC  KOM,4
	BSF  PORTB,2  ;
	CALL MKS60;		
	BSF PORTB,2  ;
	CALL MKS500;
;  5
	BCF  PORTB,2  ;
	CALL MKS05;
	BTFSC  KOM,5
	BSF PORTB,2  ;
	CALL MKS60;		
	BSF PORTB,2  ;
	CALL MKS500;
;  6
	BCF  PORTB,2  ;
	CALL MKS05;
	BTFSC  KOM,6
	BSF  PORTB,2  ;
	CALL MKS60;		
	BSF  PORTB,2  ;
	CALL MKS500;
;  7
	BCF  PORTB,2  ;
	CALL MKS05;
	BTFSC  KOM,7
	BSF  PORTB,2  ;
	CALL MKS60;		
	BSF PORTB,2  ;
	CALL MKS500;

		RETURN


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;        1  
READ1:
	CLRF  BUF_BX
					;  0  
	BCF PORTB,2  ;
	CALL MKS05;
	BSF PORTB,2  ;
	CALL MKS10; 
	CALL RB2_PR  ;
	BTFSC  PORTB,2  
	BSF  BUF_BX,0
	CALL RB2_WY  ;
	CALL MKS500;
					;  1  
	BCF PORTB,2  ;
	CALL MKS05;
	BSF PORTB,2  ;
	CALL MKS10;  
	CALL RB2_PR  ;
	BTFSC  PORTB,2  ;
	BSF  BUF_BX,1
	CALL RB2_WY  ;
	CALL MKS500;
					;  2  
	BCF PORTB,2  ;
	CALL MKS05;
	BSF PORTB,2  ;
	CALL MKS10;  
	CALL RB2_PR  ;
	BTFSC PORTB,2  ;
	BSF  BUF_BX,2
	CALL RB2_WY  ;
	CALL MKS500;
					;  3  
	BCF  PORTB,2  ;
	CALL MKS05;
	BSF PORTB,2  ;
	CALL MKS10;  
	CALL RB2_PR  ;
	BTFSC PORTB,2  ;
	BSF  BUF_BX,3
	CALL RB2_WY  ;
	CALL MKS500;
					;  4  
	BCF PORTB,2  ;
	CALL MKS05;
	BSF  PORTB,2  ;
	CALL MKS10;  
	CALL RB2_PR  ;
	BTFSC PORTB,2  ;
	BSF  BUF_BX,4
	CALL RB2_WY  ;
	CALL MKS500;

					;  5  
	BCF  PORTB,2  ;
	CALL MKS05;
	BSF  PORTB,2  ;
	CALL MKS10;
 	CALL RB2_PR  ;
	BTFSC PORTB,2  ;
	BSF  BUF_BX,5
	CALL RB2_WY  ;
	CALL MKS500;
					;  6  
	BCF PORTB,2  ;
	CALL MKS05;
	BSF PORTB,2  ;
	CALL MKS10;  
	CALL RB2_PR  ;
	BTFSC PORTB,2  ;
	BSF  BUF_BX,6
	CALL RB2_WY  ;
	CALL MKS500;
					;  7  
	BCF PORTB,2  ;
	CALL MKS05;
	BSF PORTB,2  ;
	CALL MKS10;  
	CALL RB2_PR  ;
	BTFSC PORTB,2  ;
	BSF  BUF_BX,7
	CALL RB2_WY  ;
	CALL MKS500;

		RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;  PORTB,2    
RB2_PR:         ;
	MOVLW  b'00000110' ;
	BSF  STATUS,5	;    1
	TRIS PORTB ;	   PORTB,2     
	BCF  STATUS,5;    0	
	RETURN

;  PORTB,2    
RB2_WY: ;
	MOVLW b'00000010';
	BSF  STATUS,5	;    1
	TRIS PORTB ;	   PORTB,2    
	BCF  STATUS,5;    0	
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;    6   Z6T
Z6T:            NOP
                NOP
                NOP

  

	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    1   

MS01:	CLRWDT

	MOVLW	.100
           	MOVWF OZU1
MS01_1:             CALL Z6T
               DECFSZ OZU1,1
	 GOTO MS01_1
               RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

IND250:
  	            ;    1 
			MOVLW	.250
           	MOVWF BUF

IND250_1:
	BSF  PORTB,7
 	MOVF MIN,0
	MOVWF  PORTA
	BCF  PORTB,4
	CALL  MS01	


	BSF  PORTB,4
 	MOVF DMIN,0 
	MOVWF  PORTA
	BCF  PORTB,5
	CALL  MS01	

	BSF  PORTB,5
	MOVF UHR,0
	MOVWF  PORTA
	BCF  PORTB,6
	CALL  MS01	

	BSF  PORTB,6
	MOVF DUHR,0   
	MOVWF  PORTA
	BCF  PORTB,7
	CALL  MS01	
	
             CALL MS01
               DECFSZ BUF,1
	 GOTO IND250_1

		RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;    10   

MS10:	CLRWDT
			CALL MS01
			CALL MS01
			CALL MS01
			CALL MS01
			CALL MS01
			CALL MS01
			CALL MS01
			CALL MS01
			CALL MS01
			CALL MS01
               RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    5  
MKS05:

	RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   10  
MKS10:
	CLRWDT
	NOP
	NOP
	NOP
	NOP
	RETURN	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    60  
MKS60:
	CALL  MKS10
	CALL  MKS10
	CALL  MKS10
	CALL  MKS10
	CALL  MKS10
	CALL  MKS10
	RETURN		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;    500  
MKS500:
	CLRWDT
	MOVLW	.50
           	MOVWF OZU1
MKS500_1:             CALL Z6T
               DECFSZ OZU1,1
	 GOTO MKS500_1
   	RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;    90  
MKS90:    
	CLRWDT
	MOVLW	.9
           	MOVWF OZU1
MKS90_1:             CALL Z6T
              DECFSZ OZU1,1
	 GOTO MKS90_1

	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;    100  
MKS100:    
	CLRWDT
	MOVLW	.10
           	MOVWF OZU1
MKS100_1:             CALL Z6T
               DECFSZ OZU1,1
	 GOTO MKS100_1

	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    PIC12F629
PRIEM_T:
	BTFSS  PIR1,5
	RETURN	   
	MOVF RCREG,0 ;     
	MOVWF BUF_PRI
	BCF  PIR1,5 ;        USART
;    (  )   RB3  "0"  "1"  ,
;       
	BTFSS  PORTB,3
	GOTO  S1
	GOTO  S2
S1: BCF   PORTB,3
	GOTO  S3
S2: BSF   PORTB,3

S3:
;,   :     ( -  9  )
	BTFSS RCSTA,0 ; 9-  ( )
	GOTO  B_UHR

;      ()     
	MOVF  BUF_PRI,0 ; 
	ANDLW  b'00001111'
	MOVWF  MIN
;      ()      
	SWAPF  BUF_PRI,0 ;   
	ANDLW  b'00001111'
	MOVWF  DMIN
	BSF INTCON,6 ;   
	BSF INTCON,7 ;     
	BSF  PIE1,5 ;     USART
	BCF  PIR1,5 ;        USART
;    (  )   RB3  "0"  "1"  ,
;       
	BTFSC  PORTB,3
	GOTO  RAZ1
	GOTO  RAZ2
RAZ1: BCF   PORTB,3
	GOTO  RAZ3
RAZ2: BSF   PORTB,3
RAZ3:
			RETURN
B_UHR:
;      ()     
	MOVF  BUF_PRI,0 ;
	ANDLW  b'00001111'
	MOVWF  UHR
;      ()      
	SWAPF  BUF_PRI,0
	ANDLW  b'00001111'
	MOVWF  DUHR
	BCF  PIR1,5 ;        USART

			RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		org 0x400		
TAB1:				;      (0,1,2,3,4,5,6,7,8,9, A)
		MOVWF BUF		   ;
		MOVLW 0X04		   ;
		MOVWF PCLATH	   ;
		MOVF BUF,0		   ;
		ADDWF PCL, F	   ;
;             0           1           2           3           4           5            6           7          8                               
	dt b'10100000', b'11111001', b'01100100', b'01110000', b'00111001', b'00110010', b'00100010', b'11111000', b'00100000', 
;          9          A()          B             C            D           E          F
	dt b'00110000', b'11111111', b'11111111', b'11111111', b'11111111', b'11111111', b'11111111', b'11111111', b'11111111' ;
		RETURN			   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		org 0x500		
TAB1_D:				;      (0,1,2,3,4,5,6,7,8,9, A)-  -  
		MOVWF BUF		   ;
		MOVLW 0X05		   ;
		MOVWF PCLATH	   ;
		MOVF BUF,0		   ;
		ADDWF PCL, F	   ;
;             0           1           2           3           4           5            6           7          8           9                
 	dt b'11111111', b'11111001', b'01100100', b'01110000', b'00111001', b'00110010', b'00100010', b'11111000', b'00100000', b'00110000'
;             A()   B ()          C (E)         D (r)          E          F
 	dt b'10011100', b'11000110', b'10000110', b'10101111', b'10011001', b'10010010'
		RETURN			   ;



;;;;;;;;;;;;;;;;;;;;;;;;;
		org 0x600		
TAB_HEX_ED:			   ;     , 
		MOVWF BUF		   ;
		MOVLW 0X06		   ;
		MOVWF PCLATH	   ;
		MOVF BUF,0		   ;
		ADDWF PCL, F	   ;
;	00 - 09
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9	
;	A - 13
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9
	dt  .0, .1,	.2,	.3, .4,	.5,	.6,	.7,	.8, .9
	dt  0BH, 0DH, 0CH, 0DH, 0EH, 0FH

		RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;

		org 0x700		
TAB_HEX_DES:			   ;     , 
		MOVWF BUF		   ;
		MOVLW 0X07		   ;
		MOVWF PCLATH	   ;
		MOVF BUF,0		   ;
		ADDWF PCL, F	   ;
;	00 - 09
	dt  .0, .0,	.0,	.0, .0,	.0,	.0,	.0,	.0, .0	
;	A - 13
	dt  .1, .1,	.1,	.1, .1,	.1,	.1,	.1,	.1, .1
	dt  .2, .2,	.2,	.2, .2,	.2,	.2,	.2,	.2, .2
	dt  .3, .3,	.3,	.3, .3,	.3,	.3,	.3,	.3, .3
	dt  .4, .4,	.4,	.4, .4,	.4,	.4,	.4,	.4, .4
	dt  .5, .5,	.5,	.5, .5,	.5,	.5,	.5,	.5, .5
	dt  .6, .6,	.6,	.6, .6,	.6,	.6,	.6,	.6, .6
	dt  .7, .7,	.7,	.7, .7,	.7,	.7,	.7,	.7, .7
	dt  .8, .8,	.8,	.8, .8,	.8,	.8,	.8,	.8, .8
	dt  .9, .9,	.9,	.9, .9,	.9,	.9,	.9,	.9, .9
	dt  0AH, 0CH, 0CH, 0DH, 0EH, 0FH
		RETURN


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			ORG 0X00002007   ;    
			DW  0X3F14

	END
