;          PIC12F675
;   1 


;	list	P=PIC12F629		
	list	P=PIC12F675	 
;#include <P12F629.INC>
    #include <P12F675.INC>
 
; 

SEK         	EQU    	21h ;   
MIN         	EQU    	22h ;  
UHR         	EQU    	23h ;    
BUF_SDW      	EQU    	24h ;,   
BUF          	EQU    	25h ;     
PRI_KOR			EQU    	26h ;     

;    12F675  -3F00  (LP      32,768 )
; :

;7 	-GP0 -    USART   PIC16F628
;6 	-GP1 -   PIC16    
;5 	-GP2-       
;4 	-GP3-  ,,  
;3 	-GP4-    LP 32 
;2 	-GP5-    LP 32 
;1      -VDD - +5V
;8      -VSS - GND



		org 0
		GOTO SBROS
		ORG 4
		GOTO PRER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SBROS:

;		      
	CLRF INTCON ;      
	BCF STATUS,RP0;  0
	CLRF GPIO
	MOVLW b'00000111'
	MOVWF CMCON;   
	CLRF ADCON0 ;  
	BSF STATUS,RP0 ;  1
	MOVLW b'00001110'
	MOVWF TRISIO;	tris GPIO ; 0  GPIO     ,  1, 2  3 -  
	BCF OPTION_REG,7 ;    
	MOVLW b'00000110';    GP1, GP2
	MOVWF WPU;
	CLRF ANSEL;  	
	BCF STATUS,RP0;  0
	CLRF GPIO
;	BSF  GPIO,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;     
		CLRF   SEK
		CLRF   MIN
		CLRF   UHR
;   TMR1
	MOVLW b'11100000'
	MOVWF TMR1H;     1
	CLRF T1CON
	BSF T1CON,0 ; 1
	BCF PIR1,0 ;     1
	BSF STATUS,5;  1

	CLRF INTCON
	BSF INTCON,6 ;      
	BSF INTCON,7 ;   
	BSF PIE1,0 ;    1
	BCF STATUS,5 ;  0


ZIKL:		; ,      
		GOTO ZIKL

PRER:
	BCF T1CON,0 ;  1 
	MOVLW b'11100000'
	MOVWF TMR1H;     1  
	MOVLW b'00001101'
	MOVWF TMR1L;     1  
	BSF T1CON,0 ; 1
	BCF PIR1,0 ;      1
	BSF STATUS,5;        1
	CLRF INTCON;           
	BSF INTCON,6;        
	BSF INTCON,7;       
	BSF PIE1,0 ;    1
	BCF STATUS,5;       0
; ,     ,    PIC16
		BTFSC  GPIO,1
		GOTO  UW_T

	BTFSC  GPIO,2
	GOTO   UW_T  ;   ,     
	BTFSC  PRI_KOR,0;  ,     
	GOTO  UB_UHR;     

		BSF    PRI_KOR,0 ;    
		CLRF   SEK	;     

; ,    . ,  ;  ,   .
			BTFSS  MIN,5
			GOTO   K1
		CLRF   MIN
		GOTO   UB_UHR;     

K1:
		CLRF   MIN
		GOTO   PER_T;   ,    


	GOTO   PER_T ;   ,    
UW_T:
		BCF    PRI_KOR,0 ;    
;    1 
		INCF  SEK,1
		MOVF  SEK,0
				XORLW b'00111100'
				BTFSS  STATUS,Z
		GOTO  PER_T
				CLRF  SEK

		INCF  MIN,1
		MOVF  MIN,0
				XORLW b'00111100'
				BTFSS  STATUS,Z
		GOTO  PER_T
				CLRF  MIN

UB_UHR:
		INCF UHR,1
		MOVF UHR,0
				XORLW b'00011000'
				BTFSS  STATUS,Z
		GOTO  PER_T
				CLRF  UHR



PER_T:
;   GPIO,0     USART   ,     PIC16
		BTFSC  GPIO,1
		RETURN

	MOVF MIN,0
	MOVWF BUF
	CALL TAB
	MOVWF BUF_SDW; 
		CALL  PER_MIN
		NOP
		NOP
		NOP
		NOP
	MOVF UHR,0
	MOVWF BUF
	CALL TAB
	MOVWF BUF_SDW; 
		CALL  PER_UHR ;

	RETURN

;///////////////////////////////////////////
;      
PER_MIN:
	MOVWF BUF_SDW;
	COMF BUF_SDW,1;
	NOP
	BSF  GPIO,0
	NOP
	MOVF  BUF_SDW,0
		MOVWF   GPIO ;  0     GPIO,0
	NOP
	RRF  BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  1     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  2     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  3     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  4     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  5     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  6     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  7     GPIO,0
	NOP
	NOP
	BCF  GPIO,0
;	BSF  GPIO,0
			NOP
			NOP
	BCF  GPIO,0
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP
			NOP

			RETURN

;///////////////////////////////////////////
;      
PER_UHR:

	MOVWF BUF_SDW;
	COMF BUF_SDW,1;
	NOP
	BSF  GPIO,0
	NOP
	MOVF  BUF_SDW,0
		MOVWF   GPIO ;  0     GPIO,0
	NOP
	RRF  BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  1     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  2     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  3     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  4     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  5     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  6     GPIO,0
	MOVWF  BUF_SDW ;   
	RRF 	BUF_SDW,0 ;    B W
		MOVWF   GPIO ;  7     GPIO,0
	NOP
	NOP
;	BCF  GPIO,0
	BSF  GPIO,0
			NOP
			NOP
	BCF  GPIO,0
			NOP


			RETURN







;///////////////////////////////////////////

		org 0x200		
	TAB:				;      -     PIC16
		MOVWF BUF		   ;
		MOVLW 0X0A		   ;
		MOVWF PCLATH	   ;
		MOVF BUF,0		   ;
		ADDWF PCL, F	   ;
	dt 000H, 001H, 002H, 003H, 004H, 005H, 006H, 007H, 008H, 009H, 010H, 011H, 012H, 013H, 014H, 015H, 016H, 017H, 018H, 019H
	dt 020H, 021H, 022H, 023H, 024H, 025H, 026H, 027H, 028H, 029H, 030H, 031H, 032H, 033H, 034H, 035H, 036H, 037H, 038H, 039H
	dt 040H, 041H, 042H, 043H, 044H, 045H, 046H, 047H, 048H, 049H, 050H, 051H, 052H, 053H, 054H, 055H, 056H, 057H, 058H, 059H


		RETURN			   ;
;///////////////////////////////////////////
		ORG 0X00002007   ;    
			DW  0X3F80   ;   , LP-,    


		END
